#define WIN32_LEAN_AND_MEAN
#define UNICODE
#ifdef UNICODE
  #define _UNICODE
#endif
#define _CRTIMP __declspec(dllimport)
#include <windows.h>

#define SE_DEBUG_PRIVILEGE 20
#define ADJUST_CURRENT_PROCESS 0
extern "C" __declspec(dllimport) LONG WINAPI RtlAdjustPrivilege(DWORD, BOOL, DWORD, DWORD*);

#define STATUS_INFO_LENGTH_MISMATCH (LONG(0xC0000004L))
#define SystemHandleInformation 16

typedef struct _SYSTEM_HANDLE_TABLE_ENTRY_INFO {
    USHORT UniqueProcessId;
    USHORT CreatorBackTraceIndex;
    UCHAR ObjectTypeIndex;
    UCHAR HandleAttributes;
    USHORT HandleValue;
    PVOID Object;
    ULONG GrantedAccess;
} SYSTEM_HANDLE_TABLE_ENTRY_INFO, *PSYSTEM_HANDLE_TABLE_ENTRY_INFO;

typedef struct _SYSTEM_HANDLE_INFORMATION {
    ULONG NumberOfHandles;
    SYSTEM_HANDLE_TABLE_ENTRY_INFO Handles[ 1 ];
} SYSTEM_HANDLE_INFORMATION, *PSYSTEM_HANDLE_INFORMATION;

extern "C" __declspec(dllimport) LONG WINAPI NtQuerySystemInformation (
    DWORD SystemInformationClass,
    PVOID SystemInformation,
    ULONG SystemInformationLength,
    PULONG ReturnLength
    );

#define ObjectNameInformation 1

extern "C" __declspec(dllimport) LONG WINAPI NtQueryObject (
    HANDLE ObjectHandle,
    DWORD ObjectInformationClass,
    PVOID ObjectInformation,
    ULONG ObjectInformationLength,
    PULONG ReturnLength
    );

/////////////////////////////////////////////////////////
#define  DbgSsApiPortNameW L"\\DbgSsApiPort"
typedef struct _OBJECT_NAME_PRIVATE {
  USHORT Length;
  USHORT MaximumLength;
  PWSTR  Buffer;
  WCHAR  ObjName[sizeof(DbgSsApiPortNameW)/sizeof(WCHAR)];
} OBJECT_NAME_PRIVATE, *POBJECT_NAME_PRIVATE;

BOOL FindDbgSsApiPortHandle(VOID) {
  BOOL Result = FALSE;
  HANDLE hPort;
  DWORD i;
  LONG Status;
  ULONG BufSize = 0x20000-0x8000;
  PSYSTEM_HANDLE_INFORMATION HandleInfo = NULL;
  OBJECT_NAME_PRIVATE ObjNamePriv;

  do {
    BufSize += 0x8000;
    if(HandleInfo)
      VirtualFree(HandleInfo, 0, MEM_RELEASE);
    HandleInfo = (PSYSTEM_HANDLE_INFORMATION)VirtualAlloc(NULL, BufSize, MEM_COMMIT, PAGE_READWRITE);
    if(HandleInfo == NULL)
      return(FALSE);
    Status = NtQuerySystemInformation(SystemHandleInformation, HandleInfo, BufSize, NULL);
  } while(Status == STATUS_INFO_LENGTH_MISMATCH);

  if(Status < 0) {
    VirtualFree(HandleInfo, 0, MEM_RELEASE);
    return(FALSE);
  }

  DWORD ActualProcessId = 0xFFFFFFFFF;
  HANDLE hProcess = NULL;
  for(i=0; HandleInfo->NumberOfHandles--; i++) {
    if(HandleInfo->Handles[i].UniqueProcessId != ActualProcessId) {
      if(hProcess)
        CloseHandle(hProcess);
      ActualProcessId = HandleInfo->Handles[i].UniqueProcessId;
      hProcess = OpenProcess(PROCESS_DUP_HANDLE, FALSE, ActualProcessId);
    }
    if(hProcess)
      if(DuplicateHandle(hProcess, (HANDLE)HandleInfo->Handles[i].HandleValue, (HANDLE)-1, &hPort, WRITE_DAC, FALSE, 0)) {
        ObjNamePriv.Buffer = NULL;
        if(NtQueryObject(hPort, ObjectNameInformation, &ObjNamePriv, sizeof(ObjNamePriv), NULL) >= 0) {
          if(ObjNamePriv.Buffer && (sizeof(ObjNamePriv.ObjName)-sizeof(WCHAR) == ObjNamePriv.Length)) {
            ObjNamePriv.Buffer[sizeof(ObjNamePriv.ObjName)/sizeof(WCHAR)-1] = '\0';
              if(wcscmp(ObjNamePriv.Buffer, DbgSsApiPortNameW) == 0) {
                Result = TRUE;
                TCHAR ch;
                BYTE sd[SECURITY_DESCRIPTOR_MIN_LENGTH];
                InitializeSecurityDescriptor(&sd, SECURITY_DESCRIPTOR_REVISION);
                BYTE dacl[28];
                InitializeAcl((PACL)&dacl, sizeof(dacl), ACL_REVISION);
                PSID LocalSystemSID;
                static SID_IDENTIFIER_AUTHORITY siaNTAuthority = SECURITY_NT_AUTHORITY; 
                AllocateAndInitializeSid(&siaNTAuthority, 1, SECURITY_LOCAL_SYSTEM_RID, 0, 0, 0, 0, 0, 0, 0, &LocalSystemSID);
                AddAccessAllowedAce((PACL)&dacl, ACL_REVISION, 0x1F0001, LocalSystemSID);
                //PSID LocalAdminsSID;
                //AllocateAndInitializeSid(&siaNTAuthority, 2, SECURITY_BUILTIN_DOMAIN_RID, DOMAIN_ALIAS_RID_ADMINS, 0, 0, 0, 0, 0, 0, &LocalAdminsSID);
                //AddAccessAllowedAce((PACL)&dacl, ACL_REVISION, 0x000001, LocalAdminsSID);
                SetSecurityDescriptorDacl(&sd, TRUE, (PACL)&dacl, FALSE);
                SetKernelObjectSecurity(hPort, DACL_SECURITY_INFORMATION, &sd);
                FreeSid(LocalSystemSID);
                //FreeSid(LocalAdminsSID);
                CloseHandle(hPort);
                break;
              }
          }
        }
        CloseHandle(hPort);
      }
  }
  VirtualFree(HandleInfo, 0, MEM_RELEASE);
  return(Result);
}

/////////////////////////////////////////////////////////
VOID xmain(VOID) {
  DWORD WasEn;
  RtlAdjustPrivilege(SE_DEBUG_PRIVILEGE, TRUE, ADJUST_CURRENT_PROCESS, &WasEn);
  FindDbgSsApiPortHandle();
}